var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

module.exports = function(env) {
  var Promise, SmartmeterObis, SmartmeterObisDevice, SmartmeterObisPlugin, assert;
  Promise = env.require('bluebird');
  assert = env.require('cassert');
  SmartmeterObis = require('smartmeter-obis');
  SmartmeterObisPlugin = (function(superClass) {
    extend(SmartmeterObisPlugin, superClass);

    function SmartmeterObisPlugin() {
      this.init = bind(this.init, this);
      return SmartmeterObisPlugin.__super__.constructor.apply(this, arguments);
    }

    SmartmeterObisPlugin.prototype.init = function(app, framework1, config1) {
      var deviceConfigDef;
      this.framework = framework1;
      this.config = config1;
      deviceConfigDef = require('./device-config-schema');
      return this.framework.deviceManager.registerDeviceClass('SmartmeterObisDevice', {
        configDef: deviceConfigDef.SmartmeterObisDevice,
        createCallback: (function(_this) {
          return function(config) {
            return new SmartmeterObisDevice(config, _this.framework, deviceConfigDef.SmartmeterObisDevice);
          };
        })(this)
      });
    };

    return SmartmeterObisPlugin;

  })(env.plugins.Plugin);
  SmartmeterObisDevice = (function(superClass) {
    extend(SmartmeterObisDevice, superClass);

    SmartmeterObisDevice.prototype.actualusage = 0.0;

    SmartmeterObisDevice.prototype.totalusage = 0.0;

    SmartmeterObisDevice.prototype.tariff1totalusage = 0.0;

    SmartmeterObisDevice.prototype.tariff2totalusage = 0.0;

    SmartmeterObisDevice.prototype.gastotalusage = 0.0;

    SmartmeterObisDevice.prototype.totaldelivery = 0.0;

    SmartmeterObisDevice.prototype.tariff1totaldelivery = 0.0;

    SmartmeterObisDevice.prototype.tariff2totaldelivery = 0.0;

    function SmartmeterObisDevice(config, framework, configDef) {
      this.processData = bind(this.processData, this);
      this._setAttr = bind(this._setAttr, this);
      var attr, fn, i, j, len, ref, schema;
      this.config = config;
      this.id = this.config.id;
      this.name = this.config.name;
      schema = configDef.properties;
      this.options = {
        protocol: this.config.protocol ? this.config.protocol : config.protocol,
        transport: "SerialResponseTransport",
        transportSerialPort: this.config.serialPort != null ? this.config.serialPort : config.serialPort,
        transportSerialBaudrate: this.config.baudRate != null ? this.config.baudRate : config.baudRate,
        transportSerialDataBits: this.config.dataBits != null ? this.config.dataBits : config.dataBits,
        transportSerialParity: this.config.parity != null ? this.config.parity : config.parity,
        transportSerialStopBits: this.config.stopBits != null ? this.config.stopBits : config.stopBits,
        requestInterval: this.config.requestInterval != null ? this.config.requestInterval : config.requestInterval,
        obisNameLanguage: 'en',
        debug: this.config.debuglevel != null ? this.config.debuglevel : config.debuglevel
      };
      this.smartmeterObis = SmartmeterObis.init(this.options, this.processData);
      this.smartmeterObis.process();
      this.smartmeterLogged = false;
      this.obisNotSupprtedMsg = false;
      this.attributes = {};
      ref = this.config.obisValues;
      fn = (function(_this) {
        return function(attr) {
          var acr, err, getter, name, obs, ref1, uni;
          try {
            name = attr.name;
            obs = attr.obis;
            acr = attr.acronym;
            uni = attr.unit;
            if (ref1 = !name, indexOf.call(schema.obisValues.items.properties.name["enum"], ref1) >= 0) {
              throw new Error("Illegal attribute name: " + name + " in Smartmeter config.");
            }
            switch (name) {
              case "totalusage":
                getter = (function() {
                  return Promise.resolve(_this.totalusage);
                });
                _this._setAttr(attr, "number", "1-0:1.8.0", "T in", "kWh");
                break;
              case "tariff1totalusage":
                getter = (function() {
                  return Promise.resolve(_this.tariff1totalusage);
                });
                _this._setAttr(attr, "number", "1-0:1.8.1", "T1 in", "kWh");
                break;
              case "tariff2totalusage":
                getter = (function() {
                  return Promise.resolve(_this.tariff2totalusage);
                });
                _this._setAttr(attr, "number", "1-0:1.8.2", "T2 in", "kWh");
                break;
              case "actualusage":
                getter = (function() {
                  return Promise.resolve(_this.actualusage);
                });
                _this._setAttr(attr, "number", "1-0:1.7.0", "actual", "kW");
                break;
              case "gastotalusage":
                getter = (function() {
                  return Promise.resolve(_this.gastotalusage);
                });
                _this._setAttr(attr, "number", "0-1:24.2.1", "Gas", "m3");
                break;
              case "totaldelivery":
                getter = (function() {
                  return Promise.resolve(_this.totaldelivery);
                });
                _this._setAttr(attr, "number", "1-0:2.8.0", "T out", "kWh");
                break;
              case "tariff1totaldelivery":
                getter = (function() {
                  return Promise.resolve(_this.tariff1totaldelivery);
                });
                _this._setAttr(attr, "number", "1-0:2.8.1", "T1 out", "kWh");
                break;
              case "tariff2totaldelivery":
                getter = (function() {
                  return Promise.resolve(_this.tariff2totaldelivery);
                });
                _this._setAttr(attr, "number", "1-0:2.8.2", "T2 out", "kWh");
                break;
              default:
                throw new Error("Illegal attribute name: " + name + " in Smartmeter.");
            }
            return _this._createGetter(name, getter);
          } catch (error) {
            err = error;
            return env.logger.error(err.message);
          }
        };
      })(this);
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        attr = ref[i];
        fn(attr);
      }
      SmartmeterObisDevice.__super__.constructor.call(this);
    }

    SmartmeterObisDevice.prototype._setAttr = function(attr, t, obs, acr, uni) {
      return this.attributes[attr.name] = {
        description: attr.name,
        type: t,
        obis: !(attr.obis != null) ? obs : attr.obis,
        acronym: !(attr.acronym != null) ? acr : attr.acronym,
        unit: !(attr.unit != null) ? uni : attr.unit
      };
    };

    SmartmeterObisDevice.prototype.processData = function(err, obisResult) {
      var i, log, name, obisId, ref, results;
      if (err) {
        env.logger.error(err);
        return;
      }
      if (this.options.debug === 2) {
        env.logger.debug(obisResult);
      }
      if (this.config.capabilityLog && !this.smartmeterLogged) {
        log = "Smartmeter Capabilities (Obis ID: Description = Current Value):" + '\n';
        for (obisId in obisResult) {
          log = log + obisResult[obisId].idToString() + ': ' + SmartmeterObis.ObisNames.resolveObisName(obisResult[obisId], this.options.obisNameLanguage).obisName + ' = ' + obisResult[obisId].valueToString() + '\n';
        }
        this.smartmeterLogged = true;
        env.logger.info(log);
      }
      ref = this.attributes;
      results = [];
      for (name in ref) {
        i = ref[name];
        results.push((function(_this) {
          return function(name) {
            var _actualUsage, _gasTotalUsage, _tariff1TotalDelivery, _tariff1TotalUsage, _tariff2TotalDelivery, _tariff2TotalUsage, _totalDelivery, _totalUsage, ref1;
            try {
              if (!(obisResult[i.obis] != null)) {
                if (!_this.obisNotSupprtedMsg) {
                  env.logger.info(("Your smartmeter does't support OBIS value: " + i.obis + " = ") + name);
                  _this.obisNotSupprtedMsg = true;
                }
                return;
              }
              switch (name) {
                case "actualusage":
                  if (obisResult[i.obis] != null) {
                    _actualUsage = obisResult[i.obis].values[0].value;
                  } else {
                    _actualUsage = 0;
                  }
                  _this.actualusage = Number(_actualUsage);
                  return _this.emit("actualusage", Number(_this.actualusage));
                case "totalusage":
                  if (obisResult[i.obis] != null) {
                    _totalUsage = obisResult[i.obis].values[0].value;
                  } else {
                    _totalUsage = 0;
                  }
                  _this.totalusage = Number(_totalUsage);
                  return _this.emit("totalusage", Number(_this.totalusage));
                case "tariff1totalusage":
                  if (((ref1 = obisResult[i.obis]) != null ? ref1.values[0].value : void 0) != null) {
                    _tariff1TotalUsage = obisResult[i.obis].values[0].value;
                  } else {
                    _tariff1TotalUsage = 0;
                  }
                  _this.tariff1totalusage = Number(_tariff1TotalUsage);
                  return _this.emit("tariff1totalusage", Number(_this.tariff1totalusage));
                case "tariff2totalusage":
                  if (obisResult[i.obis] != null) {
                    _tariff2TotalUsage = obisResult[i.obis].values[0].value;
                  } else {
                    _tariff2TotalUsage = 0;
                  }
                  _this.tariff2totalusage = Number(_tariff2TotalUsage);
                  return _this.emit("tariff2totalusage", Number(_this.tariff2totalusage));
                case "gastotalusage":
                  if (obisResult[i.obis] != null) {
                    _gasTotalUsage = obisResult[i.obis].values[1].value;
                  } else {
                    _gasTotalUsage = 0;
                  }
                  _this.gastotalusage = Number(_gasTotalUsage);
                  return _this.emit("gastotalusage", Number(_this.gastotalusage));
                case "totaldelivery":
                  if (obisResult[i.obis] != null) {
                    _totalDelivery = obisResult[i.obis].values[0].value;
                  } else {
                    _totalDelivery = 0;
                  }
                  _this.totaldelivery = Number(_totalDelivery);
                  return _this.emit("totaldelivery", Number(_this.totaldelivery));
                case "tariff1totaldelivery":
                  if (obisResult[i.obis] != null) {
                    _tariff1TotalDelivery = obisResult[i.obis].values[0].value;
                  } else {
                    _tariff1TotalDelivery = 0;
                  }
                  _this.tariff1totaldelivery = Number(_tariff1TotalDelivery);
                  return _this.emit("tariff1totaldelivery", Number(_this.tariff1totaldelivery));
                case "tariff2totaldelivery":
                  if (obisResult[i.obis] != null) {
                    _tariff2TotalDelivery = obisResult[i.obis].values[0].value;
                  } else {
                    _tariff2TotalDelivery = 0;
                  }
                  _this.tariff2totaldelivery = Number(_tariff2TotalDelivery);
                  return _this.emit("tariff2totaldelivery", Number(_this.tariff2totaldelivery));
              }
            } catch (error) {
              err = error;
              return env.logger.error(err.message);
            }
          };
        })(this)(name));
      }
      return results;
    };

    SmartmeterObisDevice.prototype.destroy = function() {
      this.smartmeterObis.stop();
      return SmartmeterObisDevice.__super__.destroy.call(this);
    };

    return SmartmeterObisDevice;

  })(env.devices.Device);
  return new SmartmeterObisPlugin;
};
